import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

/**
 * Main class containing the main method. Initializes the whole
 * system.
 *
 * @author Hussein Gibbins
 */
public class GAT {

	public static void main(String[] args) {

		JFrame.setDefaultLookAndFeelDecorated(true);

		JFrame frame = new JFrame("Gridscape: Admin Tool");

		// problem... ll populated before mp assigned as listener.
		TestbedManager tbm = new TestbedManager();
		LocationList ll = tbm.getLocationList();
		MapPanel mp = new MapPanel(tbm, frame);
		mp.refresh();
		ll.addObserver(mp);

		JPanel viewPanel = new JPanel();
		JPanel editPanel = new JPanel();
		JPanel cardPanel = new JPanel();

		Controls controls = new Controls(frame, mp, tbm, cardPanel);

		ResultsTable rt = new ResultsTable();
		ViewInfoFrame vifr = new ViewInfoFrame();

		InfoFrame ifr = new InfoFrame();

		ll.addObserver(vifr);
		ll.addObserver(rt);
		ll.addObserver(ifr);

		viewPanel.setLayout(new GridLayout());
		viewPanel.add(vifr);
		viewPanel.add(rt);

		editPanel.setLayout(new GridLayout());
		editPanel.add(ifr);
		
		cardPanel.setLayout(new CardLayout());

		cardPanel.add(viewPanel, Constants.VIEW_PANEL);
		cardPanel.add(editPanel, Constants.EDIT_PANEL);
		((CardLayout)cardPanel.getLayout()).show(cardPanel, Constants.VIEW_PANEL);

		frame.setLocation(100,100);
		frame.getContentPane().setLayout(new BoxLayout(frame.getContentPane(), BoxLayout.Y_AXIS));
		frame.getContentPane().add(mp);
		//frame.getContentPane().add(controls);
		frame.getContentPane().add(cardPanel);

		frame.setJMenuBar(controls.createMenuBar());

		frame.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				System.exit(0);
			}
		});

		//frame.setResizable(false);
		frame.setResizable(true);
		frame.pack();

            	tbm.queryTop();
		ll.refresh();

		frame.setVisible(true);
	}
}
