import java.io.File;
import javax.swing.*;
import javax.swing.filechooser.*;

/**
 * File filter used to filter through only certain image file types.
 *
 * @see FileFilter
 * @author Hussein Gibbins.
 */
public class ImageFilter extends FileFilter {

    //Accept all directories and all jpg, gif and png files.
    public boolean accept(File f) {
        if (f.isDirectory()) {
            return true;
        }

        String extension = getExtension(f);
        if (extension != null) {
            if (extension.equals("jpg") ||
		extension.equals("gif") ||
                extension.equals("png")) {
                    return true;
            } else {
                return false;
            }
        }

        return false;
    }

    //The description of this filter
    public String getDescription() {
        return "*.jpg, *.gif, *.png";
    }

    public static String getExtension(File f) {
        String ext = null;
        String s = f.getName();
        int i = s.lastIndexOf('.');

        if (i > 0 &&  i < s.length() - 1) {
            ext = s.substring(i+1).toLowerCase();
        }
        return ext;
    }
}
