/*
	Panel where results of querying a grid is displayed.
*/

import javax.swing.*;
import javax.swing.table.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;

/**
 * Panel used to display query results of a particular location.
 *
 * @author Hussein Gibbins
 */
public class ResultsTable extends JPanel implements Observer {

	private Vector column_names = new Vector();
	private static JTextArea results;
        private Location loc = null;
        private LocationList ll;

	/**
	 * Creates and initialises a ResultsTable.
	 */
	public ResultsTable() {
		initialize();
	}

	private void setResults(String newResult) {
		results.setText(newResult);
		results.repaint();
	}

	private void initialize() {

		column_names.add("Attribute");
		column_names.add("Value");

		setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));

		results	= new JTextArea("");
		results.setEditable(false);
		results.setLineWrap(true);
		JScrollPane scrollpane	= new JScrollPane(results);

		JLabel queryLabel = new JLabel("Query Results");
		queryLabel.setAlignmentX(Component.CENTER_ALIGNMENT);

		add(queryLabel);
		add(scrollpane);

		setBorder(BorderFactory.createEmptyBorder(15,15,15,15));

	}

	/**
	 * Updates the results displayed by this component.
	 *
	 * @see Observer
	 */
        public void update(Observable o, Object args) {

                ll = ((LocationList)o);
                Location currentLoc = ll.getNewLocation();
		setResults(currentLoc.getAttributeData());
        }
}
