import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.lang.*;
import java.util.*;

/**
 * Panel used to display location details.
 *
 * @author Hussein Gibbins
 */
public class ViewInfoFrame extends JPanel implements Observer {
	
	private JButton update;
	private JButton delete;
	private JLabel name_l = new JLabel();
	private JLabel adr = new JLabel();
	private JLabel prt = new JLabel();
	private JLabel cntry = new JLabel();
	private JLabel baseDN = new JLabel();
	private JTextArea det = new JTextArea(3, 0);
	private Location loc = null;
	private LocationList ll;

	/**
	 * Creates and initialises a ViewInfoFrame.
	 */
	public ViewInfoFrame() {
		init();
	}

	private void init() {

		setLayout(new BorderLayout());

		/* North Panel */
		JPanel n = new JPanel();
		add(n, BorderLayout.NORTH);

		n.setLayout(new GridLayout(6,2));

		n.add(new JLabel("Name"));
		n.add(name_l);
		n.add(new JLabel("Address"));
		n.add(adr);
		n.add(new JLabel("Port Number"));
		n.add(prt);
		n.add(new JLabel("Base DN"));
		n.add(baseDN);
		n.add(new JLabel("Country"));
		n.add(cntry);
		n.add(new JLabel("Details"));

		JPanel c = new JPanel();
		add(c, BorderLayout.CENTER);
		c.setLayout(new BoxLayout(c, BoxLayout.Y_AXIS));

		det.setEditable(false);
		c.add(new JScrollPane(det));

		JPanel s = new JPanel();
		add(s, BorderLayout.SOUTH);
		s.setLayout(new GridLayout(1,2));

		setBorder(BorderFactory.createEmptyBorder(15,15,15,15));
	}

	/**
	 * Updates the panel to display the details of the location currently being examined.
	 *
	 * @see Observer
	 */
	public void update(Observable o, Object args) {

		ll = ((LocationList)o);
		Location currentLoc = ll.getNewLocation();
		name_l.setText("<html><i>"+currentLoc.getName()+"</i>");
		adr.setText("<html><i>"+currentLoc.getAddress()+"</i>");
		baseDN.setText("<html><i>"+currentLoc.getBaseDN()+"</i>");
		det.setText(currentLoc.getDetails());
		cntry.setText("<html><i>"+currentLoc.getCountryCode()+":"+currentLoc.getCountryName()+"</i>");
		prt.setText("<html><i>"+currentLoc.getPort()+"</i>");
	}
}
